Index: trunk/src/olepro32/makefile
===================================================================
--- trunk/src/olepro32/makefile	(revision 2842)
+++ trunk/src/olepro32/makefile	(revision 2842)
@@ -0,0 +1,65 @@
+# $Id: makefile,v 1.1 2000-02-21 10:33:00 sandervl Exp $
+
+#
+# PD-Win32 API
+#
+#       olepro32.dll makefile
+#
+
+PDWIN32_INCLUDE = ..\..\include
+PDWIN32_LIB = ..\..\lib
+PDWIN32_BIN = ..\..\bin
+PDWIN32_TOOLS = ..\..\tools\bin
+
+
+!include $(PDWIN32_INCLUDE)/pdwin32.mk
+
+
+CFLAGS = $(CFLAGS) -I$(PDWIN32_INCLUDE)
+CXXFLAGS = $(CXXFLAGS) -I$(PDWIN32_INCLUDE)
+
+
+TARGET = olepro32
+
+OBJS =  olepro32.obj resource.obj $(PDWIN32_LIB)/dllentry.obj
+
+all: $(TARGET).dll $(TARGET).lib
+
+
+$(TARGET).dll: $(OBJS) $(TARGET).def
+    $(LD) $(LDFLAGS) -Fm -Fe$@ $(OBJS) $(TARGET).def \
+          $(PDWIN32_LIB)/kernel32.lib $(PDWIN32_LIB)/oleaut32.lib \
+          $(PDWIN32_LIB)/odincrt.lib OS2386.LIB $(RTLLIB_O)
+    $(CP) $@ $(PDWIN32_BIN)
+
+
+lib: $(TARGET).lib $(PDWIN32_LIB)\$(TARGET).lib
+
+$(PDWIN32_LIB)\$(TARGET).lib: $(TARGET).lib
+    $(CP) $** $@
+
+$(TARGET).lib: $(TARGET)exp.def
+    $(IMPLIB) $(IMPLIBFLAGS) $@ $(TARGET)exp.def
+    $(CP) $@ $(PDWIN32_LIB)
+
+$(TARGET)exp.def: $(TARGET).def
+    $(IMPDEF) $** $@
+
+resource.asm: $(TARGET).rc
+    $(RC) $(RCFLAGS) -o resource.asm $(TARGET).rc
+
+
+dep:
+    $(DEPEND) -I$(PDWIN32_INCLUDE);$(PDWIN32_INCLUDE)\win \
+        *.c *.cpp *.h *.asm *.inc $(PDWIN32_INCLUDE)\*.h
+
+!ifndef NODEP
+!include .depend
+!endif
+
+
+clean:
+    $(RM) *.obj *.lib *.dll *.map *.pch \
+        $(PDWIN32_BIN)\$(TARGET).dll $(PDWIN32_LIB)\$(TARGET).lib \
+        resource.asm $(TARGET)exp.def
+
Index: trunk/src/olepro32/olepro32.cpp
===================================================================
--- trunk/src/olepro32/olepro32.cpp	(revision 2842)
+++ trunk/src/olepro32/olepro32.cpp	(revision 2842)
@@ -0,0 +1,82 @@
+/*
+ * OlePro32 Stubs
+ *
+ * Copyright 1999 Corel Corporation
+ *
+ * Sean Langley
+ */
+
+#include "olepro32.h"
+#include "olectl.h"
+#include <odinwrap.h>
+
+
+ODINDEBUGCHANNEL(olepro32)
+
+/*****************************************************
+ * OleIconToCursor
+ */
+HCURSOR WINAPI OleIconToCursor( HINSTANCE hinstExe, HICON hicon)
+{
+	dprintf(("(%x,%x), not implemented (olepro32.dll)\n",hinstExe,hicon));
+	return S_OK;
+}
+
+/*****************************************************
+ * OleCreatePropertyFrameIndirect
+ */
+HRESULT WINAPI OleCreatePropertyFrameIndirect( LPOCPFIPARAMS lpParams)
+{
+	dprintf(("(%p), not implemented (olepro32.dll)\n",lpParams));
+	return S_OK;
+}
+ 
+/*****************************************************
+ * OleCreatePropertyFrame
+ */
+HRESULT WINAPI OleCreatePropertyFrame( HWND hwndOwner, UINT x, UINT y,
+			LPCOLESTR lpszCaption,ULONG cObjects, LPUNKNOWN* ppUnk,
+			ULONG cPages, LPCLSID pPageClsID, LCID lcid, 
+			DWORD dwReserved, LPVOID pvReserved )
+{
+	dprintf(("(%x,%d,%d,%p,%ld,%p,%ld,%p,%x,%ld,%p), not implemented (olepro32.dll)\n",
+		hwndOwner,x,y,lpszCaption,cObjects,ppUnk,cPages,pPageClsID,
+		(int)lcid,dwReserved,pvReserved));
+	return S_OK;
+}
+ 
+/*****************************************************
+ * OleLoadPicture
+ */
+HRESULT WINAPI OleLoadPicture( LPSTREAM lpstream, LONG lSize, BOOL fRunmode,
+		            REFIID reed, LPVOID *lplpvObj )
+{
+	dprintf(("(%p,%ld,%d,%p,%p), not implemented (olepro32.dll) \n",
+		lpstream,lSize,fRunmode,reed,lplpvObj
+	));
+	return S_OK;
+}
+ 
+HRESULT WINAPI DllUnregisterServer()
+{
+	dprintf(("not implemented (olepro32.dll) \n"));
+	return S_OK;
+}
+
+HRESULT WINAPI DllRegisterServer()
+{
+	dprintf(("not implemented (olepro32.dll) \n"));
+	return S_OK;
+}
+
+HRESULT WINAPI DllCanUnloadNow( )
+{
+	dprintf(("not implemented (olepro32.dll) \n"));
+	return S_OK;
+}
+
+HRESULT WINAPI DllGetClassObject( REFCLSID rclsid, REFIID riid, LPVOID* ppv )
+{
+	dprintf(("not implemented (olepro32.dll) \n"));
+	return S_OK;
+}
Index: trunk/src/olepro32/olepro32.def
===================================================================
--- trunk/src/olepro32/olepro32.def	(revision 2842)
+++ trunk/src/olepro32/olepro32.def	(revision 2842)
@@ -0,0 +1,20 @@
+; $Id: olepro32.def,v 1.1 2000-02-21 10:33:00 sandervl Exp $
+
+;
+; Based on NT 4.0 SP6: OLEPRO32.DLL 
+;
+LIBRARY OLEPRO32 INITINSTANCE
+DATA MULTIPLE NONSHARED
+
+EXPORTS
+   OleIconToCursor			= _OleIconToCursor@8		@248
+   OleCreatePropertyFrameIndirect	= _OleCreatePropertyFrameIndirect@4 @249
+   OleCreatePropertyFrame		= _OleCreatePropertyFrame@44	@250
+   OleLoadPicture			= _OleLoadPicture@20		@251
+   OleCreatePictureIndirect		= _OleCreatePictureIndirect@16	@252
+   OleCreateFontIndirect		= _OleCreateFontIndirect@12	@253
+   OleTranslateColor			= _OleTranslateColor@12		@254
+   DllCanUnloadNow			= _DllCanUnloadNow@0		@255
+   DllGetClassObject			= _DllGetClassObject@12		@256
+   DllRegisterServer			= _DllRegisterServer@0		@257
+   DllUnregisterServer			= _DllUnregisterServer@0	@258
Index: trunk/src/olepro32/olepro32.h
===================================================================
--- trunk/src/olepro32/olepro32.h	(revision 2842)
+++ trunk/src/olepro32/olepro32.h	(revision 2842)
@@ -0,0 +1,53 @@
+/* $Id: olepro32.h,v 1.1 2000-02-21 10:33:00 sandervl Exp $ */
+/*
+ * Win32 OLE stubs for OS/2
+ *
+ * 1998/06/12
+ *
+ *
+ * Project Odin Software License can be found in LICENSE.TXT
+ *
+ */
+#ifndef __OLEPRO32_H__
+#define __OLEPRO32_H__
+
+// ><DJR 17.05.99 Force to use C-interfaces for now to prevent CALLBACK definition compiler error
+#define CINTERFACE 1
+
+#include <odin.h>
+
+// ><DJR 17.05.99 Move standard includes to before os2win.h [memcmp]
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <memory.h>
+#include <wchar.h>
+
+// ><DJR 17.05.99 Prevent CALLCONV becoming _System
+#include <win/wtypes.h>
+#include <winbase.h>
+#include "oleauto.h"
+#undef CALLCONV
+
+#include <os2win.h>
+#include <ole2ver.h>
+#include <ole.h>
+#include <winreg.h>
+
+#include "objbase.h"		// Common obj include
+#include "wine/obj_inplace.h"
+#include "wine/obj_oleobj.h"
+#include "wine/obj_surrogate.h"
+#include "wine/obj_oleview.h"
+#include "wine/obj_cache.h"
+
+#include "wine/obj_property.h"	// needed for oleundo
+#include "wine/obj_olefont.h"	// needed for oleundo
+#include "wine/obj_oleundo.h"	// for OLE_COLOR of all things :-)
+
+#include "wine/obj_picture.h"
+
+#include <heapstring.h>
+
+#endif
Index: trunk/src/olepro32/olepro32.rc
===================================================================
--- trunk/src/olepro32/olepro32.rc	(revision 2842)
+++ trunk/src/olepro32/olepro32.rc	(revision 2842)
@@ -0,0 +1,41 @@
+/* $Id: olepro32.rc,v 1.1 2000-02-21 10:33:00 sandervl Exp $ */
+
+#include "winuser.h"
+#include "odinrsrc.h"
+
+
+/////////////////////////////////////////////////////////////////////////////
+//
+// Version (based on NT 4 SP6)
+//
+
+1 VERSIONINFO
+ FILEVERSION ODIN_FILEVERSION
+ PRODUCTVERSION ODIN_PRODUCTVERSION
+ FILEFLAGSMASK 0x3fL
+ FILEFLAGS 0xaL
+ FILEOS 0x10001L
+ FILETYPE 0x1L
+ FILESUBTYPE 0x0L
+BEGIN
+    BLOCK "StringFileInfo"
+    BEGIN
+        BLOCK "040904E4"
+        BEGIN
+            VALUE "Comments", "Odin32 System Dll\0"
+            VALUE "CompanyName", "Odin Team\0"
+            VALUE "FileDescription", "\0"
+            VALUE "FileVersion", "5.0.4277\0"
+            VALUE "InternalName", "OLEPRO32\0"
+            VALUE "LegalCopyright", "Copyright (C) 1999-2000\0"
+            VALUE "LegalTrademarks", "\0"
+            VALUE "OriginalFilename", "OLEPRO32.DLL\0"
+            VALUE "ProductName", "\0"
+            VALUE "ProductVersion", "2.40\0"
+        END
+    END
+    BLOCK "VarFileInfo"
+    BEGIN
+	VALUE "Translation", 0x409, 0x04E4
+    END
+END