Index: trunk/src/crtdll/crt_string.cpp
===================================================================
--- trunk/src/crtdll/crt_string.cpp	(revision 2843)
+++ trunk/src/crtdll/crt_string.cpp	(revision 2844)
@@ -1,3 +1,3 @@
-/* $Id: crt_string.cpp,v 1.1 2000-02-03 21:37:48 sandervl Exp $ */
+/* $Id: crt_string.cpp,v 1.2 2000-02-21 10:34:01 sandervl Exp $ */
 
 /*
@@ -68,4 +68,14 @@
 
 /*********************************************************************
+ *           _strerror  	 (CRTDLL.284)
+ */
+char * CDECL CRTDLL__strerror(const char *s)
+{
+  dprintf(("CRTDLL: _strerror\n"));
+  return (_strerror((char*)s));
+}
+
+
+/*********************************************************************
  *           _stricmp  	 (CRTDLL.285)
  */
@@ -131,4 +141,5 @@
     return( (i>l) ? l : i );
 }
+
 
 /*********************************************************************
Index: trunk/src/crtdll/crtdll.cpp
===================================================================
--- trunk/src/crtdll/crtdll.cpp	(revision 2843)
+++ trunk/src/crtdll/crtdll.cpp	(revision 2844)
@@ -1,3 +1,3 @@
-/* $Id: crtdll.cpp,v 1.22 2000-02-03 21:37:48 sandervl Exp $ */
+/* $Id: crtdll.cpp,v 1.23 2000-02-21 10:34:01 sandervl Exp $ */
 
 /*
@@ -45,4 +45,5 @@
 #include <errno.h>
 #include <sys\utime.h>
+#include <sys\timeb.h>
 #include <sys\stat.h>
 #include "signal.h"
@@ -981,4 +982,14 @@
 
 /*********************************************************************
+ *	_fpreset				(CRTDLL.107)
+ */
+void CDECL CRTDLL__fpreset(void)
+{
+  dprintf(("CRTDLL: _fpreset\n"));
+  _fpreset();
+}
+
+
+/*********************************************************************
  *                  _fputchar     (CRTDLL.108)
  */
@@ -987,4 +998,24 @@
   dprintf2(("CRTDLL: _fputchar\n"));
   return(_fputchar(c));
+}
+
+
+/*********************************************************************
+ *	_fstat					(CRTDLL.111)
+ */
+int CDECL CRTDLL__fstat(int file, struct stat* buf)
+{
+  dprintf(("CRTDLL: _fstat\n"));
+  return (_fstat(file, buf));
+}
+
+
+/*********************************************************************
+ *	_ftime					(CRTDLL.112)
+ */
+void CDECL CRTDLL__ftime( struct timeb *timebuf )
+{
+  dprintf(("CRTDLL: _ftime\n"));
+  _ftime(timebuf);
 }
 
@@ -1680,4 +1711,14 @@
 
 /*********************************************************************
+ *	_sopen					(CRTDLL.268)
+ */
+int CDECL CRTDLL__sopen( const char *s, int i1, int i2, va_list arg )
+{
+  dprintf(("CRTDLL: _sopen\n"));
+  return (_sopen(s, i1, i2, arg));
+}
+
+
+/*********************************************************************
  *           CRTDLL__spawnl 	 (CRTDLL.269)
  */
@@ -3099,4 +3140,14 @@
 
 /*********************************************************************
+ *	ungetc					(CRTDLL.492)
+ */
+INT CDECL CRTDLL_ungetc(int c, FILE *f)
+{
+  dprintf(("CRTDLL: ungetc\n"));
+  return (ungetc(c, f));
+}
+
+
+/*********************************************************************
  *                  vfprintf       (CRTDLL.494)
  */
Index: trunk/src/crtdll/stubs.cpp
===================================================================
--- trunk/src/crtdll/stubs.cpp	(revision 2843)
+++ trunk/src/crtdll/stubs.cpp	(revision 2844)
@@ -1,3 +1,3 @@
-/* $Id: stubs.cpp,v 1.1 2000-02-03 21:37:50 sandervl Exp $ */
+/* $Id: stubs.cpp,v 1.2 2000-02-21 10:34:02 sandervl Exp $ */
 
 /*
@@ -69,5 +69,5 @@
 
 /*********************************************************************
- *           CRTDLL__chgsign	 (CRTDLL.53)
+ *           _chgsign	 (CRTDLL.53)
  */
 double CDECL CRTDLL__chgsign(double x)
@@ -80,5 +80,5 @@
 
 /*********************************************************************
- *                  CRTDLL__commit    (CRTDLL.58)
+ *                  _commit    (CRTDLL.58)
  */
 int CDECL CRTDLL__commit( int fd )
@@ -91,5 +91,5 @@
 
 /*********************************************************************
- *                  CRTDLL__copysign    (CRTDLL.62)
+ *                  _copysign    (CRTDLL.62)
  */
 double CDECL CRTDLL__copysign( double d, double s )
@@ -201,14 +201,4 @@
 
 /*********************************************************************
- *	_fpreset				(CRTDLL.107)
- */
-void CDECL CRTDLL__fpreset(void)
-{
-  dprintf(("CRTDLL: _fpreset not implemented.\n"));
-  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
-}
-
-
-/*********************************************************************
  *	_fputwchar				(CRTDLL.109)
  */
@@ -227,26 +217,4 @@
 {
   dprintf(("CRTDLL: _fsopen not implemented.\n"));
-  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
-  return FALSE;
-}
-
-
-/*********************************************************************
- *	_fstat					(CRTDLL.111)
- */
-int CDECL CRTDLL__fstat(int file, struct stat* buf)
-{
-  dprintf(("CRTDLL: _fstat not implemented.\n"));
-  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
-  return FALSE;
-}
-
-
-/*********************************************************************
- *	_ftime					(CRTDLL.112)
- */
-int CDECL CRTDLL__ftime( struct timeb *timebuf )
-{
-  dprintf(("CRTDLL: _ftime not implemented.\n"));
   SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
   return FALSE;
@@ -1164,26 +1132,4 @@
 
 /*********************************************************************
- *	_sopen					(CRTDLL.268)
- */
-int CDECL CRTDLL__sopen( const char *s, int i1, int i2, ... )
-{
-  dprintf(("CRTDLL: _sopen not implemented.\n"));
-  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
-  return FALSE;
-}
-
-
-/*********************************************************************
- *           _strerror  	 (CRTDLL.284)
- */
-char * CDECL CRTDLL__strerror(const char *s)
-{
-  dprintf(("CRTDLL: _strerror not implemented.\n"));
-  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
-  return FALSE;
-}
-
-
-/*********************************************************************
  *	_tzset					(CRTDLL.308)
  */
@@ -1273,15 +1219,4 @@
 
 /*********************************************************************
- *	ungetc					(CRTDLL.492)
- */
-INT CDECL CRTDLL_ungetc(int c, FILE *f)
-{
-  dprintf(("CRTDLL: ungetc not implemented.\n"));
-  SetLastError(ERROR_CALL_NOT_IMPLEMENTED);
-  return FALSE;
-}
-
-
-/*********************************************************************
  *	vfwprintf				(CRTDLL.495)
  */