Index: trunk/src/gdi32/dbglocal.cpp
===================================================================
--- trunk/src/gdi32/dbglocal.cpp	(revision 2858)
+++ trunk/src/gdi32/dbglocal.cpp	(revision 2859)
@@ -1,4 +1,3 @@
-
-/* $Id: dbglocal.cpp,v 1.1 2000-02-16 14:18:09 sandervl Exp $ */
+/* $Id: dbglocal.cpp,v 1.2 2000-02-22 19:11:48 sandervl Exp $ */
 
 /*
@@ -14,4 +13,6 @@
 #include <string.h>
 #include "dbglocal.h"
+
+#ifdef DEBUG
 
 USHORT DbgEnabled[DBG_MAXFILES];
@@ -75,2 +76,3 @@
 //******************************************************************************
 
+#endif
Index: trunk/src/gdi32/dbglocal.h
===================================================================
--- trunk/src/gdi32/dbglocal.h	(revision 2858)
+++ trunk/src/gdi32/dbglocal.h	(revision 2859)
@@ -1,3 +1,3 @@
-/* $Id: dbglocal.h,v 1.1 2000-02-16 14:18:09 sandervl Exp $ */
+/* $Id: dbglocal.h,v 1.2 2000-02-22 19:11:49 sandervl Exp $ */
 
 /*
@@ -49,5 +49,4 @@
 
 #define ParseLogStatus()
-#define DBG_LOCALLOG(a)
 
 #endif //DEBUG
Index: trunk/src/gdi32/gdi32.cpp
===================================================================
--- trunk/src/gdi32/gdi32.cpp	(revision 2858)
+++ trunk/src/gdi32/gdi32.cpp	(revision 2859)
@@ -1,3 +1,3 @@
-/* $Id: gdi32.cpp,v 1.43 2000-02-16 14:18:09 sandervl Exp $ */
+/* $Id: gdi32.cpp,v 1.44 2000-02-22 19:11:49 sandervl Exp $ */
 
 /*
@@ -1435,5 +1435,13 @@
                        INT cbOutput, LPSTR lpszOutData)
 {
-  dprintf(("GDI32: ExtEscape, not implemented\n"));
+  dprintf(("GDI32: ExtEscape, %x %x %d %x %d %x not implemented", hdc, nEscape, cbInput, lpszInData, cbOutput, lpszOutData));
+#ifdef DEBUG
+  if(cbInput && lpszInData) {
+	ULONG *tmp = (ULONG *)lpszInData;
+	for(int i=0;i<cbInput/4;i++) {
+		dprintf(("GDI32: ExtEscape par %d: %x", i, *tmp++));
+	}
+  }
+#endif
   return(0);
 }
Index: trunk/src/kernel32/dbglocal.cpp
===================================================================
--- trunk/src/kernel32/dbglocal.cpp	(revision 2858)
+++ trunk/src/kernel32/dbglocal.cpp	(revision 2859)
@@ -1,4 +1,3 @@
-
-/* $Id: dbglocal.cpp,v 1.1 2000-02-16 14:25:38 sandervl Exp $ */
+/* $Id: dbglocal.cpp,v 1.2 2000-02-22 19:12:52 sandervl Exp $ */
 
 /*
@@ -14,4 +13,6 @@
 #include <string.h>
 #include "dbglocal.h"
+
+#ifdef DEBUG
 
 USHORT DbgEnabled[DBG_MAXFILES];
@@ -150,2 +151,3 @@
 //******************************************************************************
 
+#endif
Index: trunk/src/kernel32/dbglocal.h
===================================================================
--- trunk/src/kernel32/dbglocal.h	(revision 2858)
+++ trunk/src/kernel32/dbglocal.h	(revision 2859)
@@ -1,3 +1,3 @@
-/* $Id: dbglocal.h,v 1.1 2000-02-16 14:25:38 sandervl Exp $ */
+/* $Id: dbglocal.h,v 1.2 2000-02-22 19:12:53 sandervl Exp $ */
 
 /*
@@ -124,5 +124,4 @@
 
 #define ParseLogStatus()
-#define DBG_LOCALLOG(a)
 
 #endif //DEBUG
Index: trunk/src/kernel32/winimagebase.cpp
===================================================================
--- trunk/src/kernel32/winimagebase.cpp	(revision 2858)
+++ trunk/src/kernel32/winimagebase.cpp	(revision 2859)
@@ -1,3 +1,3 @@
-/* $Id: winimagebase.cpp,v 1.8 2000-02-16 14:22:12 sandervl Exp $ */
+/* $Id: winimagebase.cpp,v 1.9 2000-02-22 19:12:53 sandervl Exp $ */
 
 /*
@@ -49,7 +49,5 @@
     ulRVAResourceSection(0)
 {
-#ifdef DEBUG
   magic = MAGIC_WINIMAGE;
-#endif
 
   if(hInstance != -1) {
Index: trunk/src/kernel32/winimagepeldr.cpp
===================================================================
--- trunk/src/kernel32/winimagepeldr.cpp	(revision 2858)
+++ trunk/src/kernel32/winimagepeldr.cpp	(revision 2859)
@@ -1,8 +1,8 @@
-/* $Id: winimagepeldr.cpp,v 1.31 2000-02-15 00:14:28 sandervl Exp $ */
+/* $Id: winimagepeldr.cpp,v 1.32 2000-02-22 19:12:53 sandervl Exp $ */
 
 /*
  * Win32 PE loader Image base class
  *
- * Copyright 1998-1999 Sander van Leeuwen (sandervl@xs4all.nl)
+ * Copyright 1998-2000 Sander van Leeuwen (sandervl@xs4all.nl)
  * Copyright 1998 Knut St. Osmundsen
  *
@@ -19,5 +19,5 @@
  *
  */
-
+#define DEBUG
 #define INCL_DOSFILEMGR          /* File Manager values      */
 #define INCL_DOSMODULEMGR
@@ -65,12 +65,9 @@
 char szErrorModule[128] = "";
 
-#ifndef max
-#define max(a, b)  ((a>b) ? a : b)
+#ifdef DEBUG
+static FILE *_privateLogFile = NULL;
 #endif
 
-static FILE *_privateLogFile = NULL;
-
 ULONG MissingApi();
-extern ULONG flAllocMem;    /*Tue 03.03.1998: knut */
 
 //******************************************************************************
@@ -78,4 +75,5 @@
 void OpenPrivateLogFilePE()
 {
+#ifdef DEBUG
  char logname[CCHMAXPATH];
 
@@ -87,4 +85,5 @@
 	}
 	dprintfGlobal(("PE LOGFILE : %s", logname));
+#endif
 }
 //******************************************************************************
@@ -92,8 +91,10 @@
 void ClosePrivateLogFilePE()
 {
+#ifdef DEBUG
   	if(_privateLogFile) {
 		fclose(_privateLogFile);
 		_privateLogFile = NULL;
 	}
+#endif
 }
 //******************************************************************************
Index: trunk/src/winmm/dbglocal.cpp
===================================================================
--- trunk/src/winmm/dbglocal.cpp	(revision 2858)
+++ trunk/src/winmm/dbglocal.cpp	(revision 2859)
@@ -1,3 +1,3 @@
-/* $Id: dbglocal.cpp,v 1.1 2000-02-17 14:10:18 sandervl Exp $ */
+/* $Id: dbglocal.cpp,v 1.2 2000-02-22 19:12:16 sandervl Exp $ */
 
 /*
@@ -8,4 +8,6 @@
  * Project Odin Software License can be found in LICENSE.TXT
  */
+#ifdef DEBUG
+
 #include <os2wrap.h>
 #include <stdlib.h>
@@ -76,2 +78,3 @@
 //******************************************************************************
 
+#endif
Index: trunk/src/winmm/dbglocal.h
===================================================================
--- trunk/src/winmm/dbglocal.h	(revision 2858)
+++ trunk/src/winmm/dbglocal.h	(revision 2859)
@@ -1,3 +1,3 @@
-/* $Id: dbglocal.h,v 1.1 2000-02-17 14:10:18 sandervl Exp $ */
+/* $Id: dbglocal.h,v 1.2 2000-02-22 19:12:16 sandervl Exp $ */
 
 /*
@@ -51,5 +51,4 @@
 
 #define ParseLogStatus()
-#define DBG_LOCALLOG(a)
 
 #endif //DEBUG